//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 22-1 #1 MASTER
//
// This communicates with another E3 running the 'EX 22-1-1b.c' file.
//
// Receive commands like "READ" and "WRITE" and send them to secondary E3.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

#include <string.h>

#include "comms.h"

#define SIZE 30

char * string_to_upper(char * pString)
{
   char *ret;
   char c;
   
   ret = pString;
   
   for(;;)
   {
      c = *pString;
      if (!c)
         break;
      *pString++ = toupper(c);
   }
   
   return(ret);
}

void main(void) 
{
   char input[SIZE];
   char *p;
   int location;
   int value;
  
  #if 0
   for(;;)
   {
      delay_ms(1000);
      if (!CommsSetGreenLEDOn()) {fprintf(STREAM_USB, "ON ERROR\r\n");}
      delay_ms(1000);
      if (!CommsSetGreenLEDOff()) {fprintf(STREAM_USB, "OFF ERROR\r\n");}
   }
  #endif
  
 #if 0
   fprintf(STREAM_USB, "Starting loop...\r\n");
   for(;;)
   {
      delay_ms(1000);
      if (!CommsReadADC(&value))
         fprintf(STREAM_USB, "ADC ERROR\r\n");
      else 
         fprintf(STREAM_USB, "POT=%u\r\n", value);
   }  
  #endif
   
   for(;;) {
      input[0] = '\0';
      fprintf(STREAM_USB, "Ready for string\r\n\r\n" );
      
      get_string_usb ( input, SIZE );
      fprintf(STREAM_USB, "\r\n");
   
      string_to_upper(input);
   
      if(!strcmp(input, "LED RED ON"))
      {
         if (!CommsSetRedLEDOn())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "LED RED OFF"))
      {
         if (!CommsSetRedLEDOff())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "LED YELLOW ON"))
      {
         if (!CommsSetYellowLEDOn())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "LED YELLOW OFF"))
      {
         if (!CommsSetYellowLEDOff())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "LED GREEN ON"))
      {
         if (!CommsSetGreenLEDOn())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "LED GREEN OFF"))
      {
         if (!CommsSetGreenLEDOff())
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
      }
      else if(!strcmp(input, "BUTTONS"))
      {
         if (!CommsReadButtons(&value))
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
         else
         {
            fprintf(STREAM_USB, "Buttons = 0x%02X\r\n", value);
         }
      }
      else if(!strcmp(input, "POT"))
      {
         if (!CommsReadADC(&value))
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
         else
         {
            fprintf(STREAM_USB, "POT = 0x%02X\r\n", value);
         }
      }
      else if (strstr(input, "READ "))
      {
         location = atoi(&input[5]);
         
         if (!CommsReadLocation(location, &value))
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
         else
         {
            fprintf(STREAM_USB, "%u = 0x%02X\r\n", location, value);
         }
      }
      else if (strstr(input, "WRITE "))
      {
         location = atoi(&input[6]);
         
         p = &input[6];
         while(*p != ' ')  p++;
         p++;
         value = atoi(p);

         if (!CommsWriteLocation(location, value))
         {
            fprintf(STREAM_USB, "ERROR: no response from secondary E3\r\n");
         }
         else
         {
            fprintf(STREAM_USB, "%u written with 0x%02X\r\n", location, value);
         }
      }
      else
         fprintf(STREAM_USB, "\r\n\r\nUnknown Command, Try Again");
      
      fprintf(STREAM_USB, "\r\n");
   }
   
   for(;;);
}

