//////////////////////////////////////////////////////////////////////////////
//
// "Embedded C Programming: Techniques and Applications of C and PIC MCUs"
// by Mark Siegusmund
//
// Exercise 22-1 #2
//
// Get NMEA data from GPS and display it over USB.
//
//////////////////////////////////////////////////////////////////////////////

#include <e3.h>

// create a new serial port using the UART peripheral of the PIC18F14K50.
// on the PIC18F14K50, PIN_B5 is receive and PIN_B7 is transmit.
#use rs232(UART1, baud=9600, errors, receive_buffer=128, stream=STREAM_GPS)

#include <input.c>

void main(void)
{
   char str[128];
   char gpgga[] = "$GPGGA,";
   char tokens[] = ",";
   int i;
   char *p, *lat, *latDir, *lon, *lonDir, *fix, *num, *time;
   
   fprintf(STREAM_USB, "\r\n\r\nex_sk_gps.c - GPS sensor board example\r\n\r\n");
   
   only_led_on(GREEN_LED);
   
   // interrupts need to be enabled in order for the #use rs232()'s 
   // receive buffering to work.
   enable_interrupts(GLOBAL);
 
   for(;;)
   {
      fgets(str, STREAM_GPS);
      
      //fprintf(STREAM_USB, "%s", str);
      
      if (strstr(str, gpgga) != 0)
      {
         //fprintf(STREAM_USB, "%s", str);
         
         output_toggle(YELLOW_LED);
         
         p = strtok(str, tokens);
         i = 0;
         while(p != NULL)
         {
            switch(i++)
            {
               case 1:  time = p;      break;
               case 2:  lat = p;       break;
               case 3:  latDir = p;    break;
               case 4:  lon = p;       break;
               case 5:  lonDir = p;    break;
               case 6:  fix = p;       break;
               case 7:  num = p;       break;
               default: break;
            }            
            p = strtok(NULL, tokens);
         }
         
         fprintf(STREAM_USB, "fix=%s, num=%s, time=%s, lat=%s %s, lon=%s %s\r\n",
               fix,
               num,
               time,
               lat,
               latDir,
               lon,
               lonDir
            );
      }
   }
}
